﻿# To do
# Death images
# Play around dead players
# Team management
# Spells that cost stamina or health
# Mana burn example
# Running out of mana
# Item use
# Flee
# Heal spells
# Spell targets
# spell tooltip

init python:
    from dataclasses import dataclass

    @dataclass
    class spell:
        name: str
        info: str
        icon: str

        health: int = 0
        mana: int = 0
        stamina: int = 0

        health_cost: int = 0
        mana_cost: int = 0
        stamina_cost: int = 0

        effect: str = ""
        sound: str = ""
        targets: str = ""

    @dataclass
    class fighter:
        name: str
        info: str
        image: str

        health: int
        mana: int
        stamina: int

        spells: list

        x: int = 0
        y: int = 0
        z: int = 1
        order: int = 0

        stat: str = "idle"
        is_alive: bool = True

        goto_target = (0,0)

        def __post_init__(self):
            self.max_health: int = self.health
            self.max_mana: int = self.mana
            self.max_stamina: int = self.stamina


    @dataclass
    class team:
        name: str
        pool: list
        x_offset: int = 0
        is_ai: bool = False

        def __post_init__(self):
            self.team: list = self.pool

    def damage_calculator(spell, caster, target):
        jitter = random.randint(-3,3)
        damage = spell.health + jitter
        # calculate the defense, armor, and critical here and add ot to the damage
        # Since we don't have that yet, let's skip that
        return damage
    class battle_handler:
        def __init__(self, bg, y_offset, team_1, team_2):
            self.bg = bg
            self.y_offset = y_offset
            self.team_1 = team_1
            self.team_2 = team_2

            self.t1_pos = [(-32, 0, 1, 1), (-80, 12, 1, 2), (-64, -10, 1, 0)]
            self.t2_pos = [(32, 0, -1, 1), (80, 12, -1, 2), (64, -10, -1, 0)]
            for i,p in zip(self.team_1.team, self.t1_pos):
                i.x, i.y, i.z, i.order = p
            for i,p in zip(self.team_2.team, self.t2_pos):
                i.x, i.y, i.z, i.order = p
            self.sort_teams()

            self.turn = []

            self.caster = None
            self.spell = None
            self.target = None

            self.winner = None

            self.stat = "start"
            self.pool = []
        def sort_teams(self):
            self.team_1.team.sort(key=lambda x: x.order, reverse=False)
            self.team_2.team.sort(key=lambda x: x.order, reverse=False)
        def hover(self, fighter):
            if not self.stat == "player_targetting":
                return
            self.target = fighter

        def start(self):
            self.pool = self.team_1.team + self.team_2.team
            random.shuffle(self.pool)
            self.stat = "wait"

        def next(self):
            self.caster = self.pool.pop(0)
            self.pool.append(self.caster)
            if self.caster in self.team_1.team:
                self.stat = "player"
            elif self.caster in self.team_2.team:
                self.stat = "enemy"
            else:
                renpy.notify("something gone wrong")


        def select_spell(self, spell):
            self.spell = spell
            self.stat = "player_targetting"

        def select_target(self, target):
            if not self.stat == "player_targetting":
                return
            self.target = target
            self.stat = "casting"

        def cast(self, after = "after_cast"):
            caster = self.caster
            target = self.target
            spell = self.spell

            renpy.play(spell.sound, "sound")
            target.stat = "shake"
            caster.goto_target = (target.x, target.y)
            caster.stat = "goto"

            damage = -damage_calculator(spell, caster, target)
            target.health += damage
            caster.mana -= spell.mana_cost

            if target.health < 1:
                target.is_alive = False
            if caster.health < 1:
                target.is_alive = False

            x, y = target.x*6, target.y*6
            floating_text(damage,x, y)
            spawn_things(spell.effect, x, y, 6)

            self.stat = after

        def after_cast(self):
            self.caster.stat = "idle"
            self.target.stat = "idle"
            self.target = None
            self.spell = None
            self.stat = "check"
        def check(self):
            t1_alive = [i for i in self.team_1.team if i.is_alive]
            if len(t1_alive) == 0:
                self.stat = "done"
                self.winner = self.team_2
                return
            t2_alive = [i for i in self.team_2.team if i.is_alive]
            if len(t2_alive) == 0:
                self.stat = "done"
                self.winner = self.team_1
                return
            self.stat = "wait"

        def enemy_ai(self):
            if not self.spell:
                self.spell = random.choice(self.caster.spells)
                return
            if not self.target:
                self.target = random.choice(self.team_1.team)
                return
            self.cast()

            # self.stat = "wait"

transform shake:
    pause .2
    ease .1 xoffset -1
    ease .1 xoffset 1
    ease .1 xoffset -1
    ease .1 xoffset 1
    ease .1 xoffset 0

transform goto(x, y):
    offset (0, 0)
    ease .1 offset (x, y)
    ease .1 offset (0, 0)


screen battle_screen():
    default g = battle_handler(
        "lab_bg",
        16,
        team("Team", [Koume, Chiyako, Seiko]),
        team("Team", [Nomi, Aira, Michi]),
        )
    fixed fit_first True:
        align .5,.5 
        add g.bg
        at zoom(6,True)
        fixed:
            yoffset g.y_offset
            for i in g.team_1.pool:
                button:
                    align .5,.5 offset i.x,i.y
                    padding 0,0 background None
                    focus_mask True
                    fixed fit_first True:
                        add i.image at flip(i.z)
                        bar value i.health range i.max_health xysize 32,1 align .5,.0
                    action Function(g.select_target, i)
                    hovered Function(g.hover, i)
                    if i.stat == "shake":
                        at shake
                    elif i.stat == "goto":
                        at goto(i.goto_target[0], i.goto_target[1])

            for i in g.team_2.pool:
                button:
                    padding 0,0 background None
                    align .5,.5 offset i.x,i.y
                    focus_mask True
                    fixed fit_first True:
                        add i.image at flip(i.z)
                        bar value i.health range i.max_health xysize 32,1 align .5,.0
                    action Function(g.select_target, i)
                    hovered Function(g.hover, i)
                    if i.stat == "shake":
                        at shake
                    elif i.stat == "goto":
                        at goto(i.goto_target[0], i.goto_target[1])

        if g.caster:
            add "battle_caster_mark" align .5,.5 offset g.caster.x, g.caster.y-20
        if g.target:
            add "battle_target_mark" align .5,.5 offset g.target.x, g.target.y-20

    if g.stat == "start":
        timer 1 action Function(g.start)
    elif g.stat == "wait":
        timer .5 action Function(g.next)
    elif g.stat == "player":
        hbox:
            align .5,1.0 spacing 2
            at zoom(6,True)
            for i in g.caster.spells:
                button:
                    padding 0,0
                    fixed fit_first True:
                        add "fight_spell_frame"
                        add i.icon
                    action Function(g.select_spell, i)
    
    elif g.stat == "player_targetting":
        text "Choose your target." align .5,.95
    elif g.stat == "enemy":
        timer .5 repeat True action Function(g.enemy_ai)

    elif g.stat == "casting":
        timer .3 action Function(g.cast)
    elif g.stat == "after_cast":
        timer .5 action Function(g.after_cast)
    elif g.stat == "check":
        timer .3 action Function(g.check)
    elif g.stat == "done":
        text "This fight is over." align .5,.95
        timer 4 action Return(g.winner)


    text g.stat


init: # spells
    image purple_hit:
        Crop((0, 256, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((0, 224, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((0, 192, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((0, 224, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((0, 256, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        ease .2 alpha 0
    image force_pinch:
        Crop((0, 64, 32, 32), "rpg_battle_2/sprites.png")
    default force_pinch = spell(
        "Force pull",
        "Pinches where it lands.",
        "force_pinch",
        40, 0, 0,
        0, 10, 0,
        "purple_hit",
        "rpg_battle_2/sounds/gravity.ogg",
        )
    image force_impact:
        Crop((0, 96, 32, 32), "rpg_battle_2/sprites.png")
    default force_impact = spell(
        "Force impact",
        "Pushes on a single point of impact.",
        "force_impact",
        50, 0, 0,
        0, 15, 0,
        "purple_hit",
        "rpg_battle_2/sounds/gravity.ogg",
        )
    image force_gravity:
        Crop((0, 128, 32, 32), "rpg_battle_2/sprites.png")
    default force_gravity = spell(
        "Force impact",
        "A bigger version of force pinch.",
        "force_gravity",
        30, 0, 0,
        0, 5, 0,
        "purple_hit",
        "rpg_battle_2/sounds/gravity.ogg",
        )

init: # spells
    image poison_hit:
        Crop((48, 256, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((48, 224, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((48, 192, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((48, 224, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((48, 256, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        ease .2 alpha 0
    image poison_scratch:
        Crop((48, 64, 32, 32), "rpg_battle_2/sprites.png")
    default poison_scratch = spell(
        "Poison scratch",
        "Scratch with poisonous nails.",
        "poison_scratch",
        25, 0, 0,
        0, 10, 0,
        "poison_hit",
        "rpg_battle_2/sounds/poison.ogg",
        )
    image poison_swirl:
        Crop((48, 96, 32, 32), "rpg_battle_2/sprites.png")
    default poison_swirl = spell(
        "Poison swirl",
        "A swirl of poisonous gases.",
        "poison_swirl",
        35, 0, 0,
        0, 20, 0,
        "poison_hit",
        "rpg_battle_2/sounds/poison.ogg",
        )
    image poison_slash:
        Crop((48, 128, 32, 32), "rpg_battle_2/sprites.png")
    default poison_slash = spell(
        "Poison slash",
        "A slash of poisonous dust.",
        "poison_slash",
        45, 0, 0,
        0, 25, 0,
        "poison_hit",
        "rpg_battle_2/sounds/poison.ogg",
        )

init: # spells
    image fire_hit:
        Crop((96, 256, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((96, 224, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((96, 192, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((96, 224, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((96, 256, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        ease .2 alpha 0
    image inner_fire:
        Crop((96, 64, 32, 32), "rpg_battle_2/sprites.png")
    default inner_fire = spell(
        "Inner fire",
        "Doubles your damage until you get hit.",
        "inner_fire",
        20, 0, 0,
        0, 10, 0,
        "fire_hit",
        "rpg_battle_2/sounds/burn.ogg",
        )
    image fire_ball:
        Crop((96, 96, 32, 32), "rpg_battle_2/sprites.png")
    default fire_ball = spell(
        "Fireball",
        "A run-of-the-mill fireball.",
        "fire_ball",
        40, 0, 0,
        0, 25, 0,
        "fire_hit",
        "rpg_battle_2/sounds/burn.ogg",
        )
    # image force_gravity:
    #     Crop((96, 128, 32, 32), "rpg_battle_2/sprites.png")
    # default poison_slash = spell(
    #     "Poison slash",
    #     "A slash of poisonous dust.",
    #     "poison_slash",
    #     40, 0, 0,
    #     0, 0, 15,
    #     "fire_hit",
    #     "rpg_battle_2/sounds/burn.ogg",
    #     )

init: # spells
    image punch_hit:
        Crop((144, 256, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((144, 224, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((144, 192, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((144, 224, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((144, 256, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        ease .2 alpha 0
    image iron_punch:
        Crop((144, 64, 32, 32), "rpg_battle_2/sprites.png")
    default iron_punch = spell(
        "Iron punch",
        "The only move that Seiko knows.",
        "iron_punch",
        40, 0, 0,
        0, 25, 0,
        "punch_hit",
        "rpg_battle_2/sounds/punches.ogg",
        )
    # image fire_ball:
    #     Crop((144, 96, 32, 32), "rpg_battle_2/sprites.png")
    # default fire_ball = spell(
    #     "Fireball",
    #     "A run-of-the-mill fireball.",
    #     "fire_ball",
    #     40, 0, 0,
    #     0, 0, 15,
    #     "punch_hit",
    #     "rpg_battle_2/sounds/punches.ogg",
    #     )
    # image force_gravity:
    #     Crop((144, 128, 32, 32), "rpg_battle_2/sprites.png")
    # default poison_slash = spell(
    #     "Poison slash",
    #     "A slash of poisonous dust.",
    #     "poison_slash",
    #     40, 0, 0,
    #     0, 0, 15,
    #     "punch_hit",
    #     "rpg_battle_2/sounds/punches.ogg",
    #     )

init: # spells
    image cut_hit:
        Crop((192, 256, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((192, 224, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((192, 192, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((192, 224, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((192, 256, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        ease .2 alpha 0
    image golden_cut:
        Crop((192, 64, 32, 32), "rpg_battle_2/sprites.png")
    default golden_cut = spell(
        "Golden cut",
        "You can lose your hair, or head.",
        "golden_cut",
        40, 0, 0,
        0, 20, 0,
        "cut_hit",
        "rpg_battle_2/sounds/slash.ogg",
        )
    # image fire_ball:
    #     Crop((192, 96, 32, 32), "rpg_battle_2/sprites.png")
    # default fire_ball = spell(
    #     "Fireball",
    #     "A run-of-the-mill fireball.",
    #     "fire_ball",
    #     40, 0, 0,
    #     0, 0, 15,
    #     "cut_hit",
    #     "rpg_battle_2/sounds/slash.ogg",
    #     )
    # image force_gravity:
    #     Crop((192, 128, 32, 32), "rpg_battle_2/sprites.png")
    # default poison_slash = spell(
    #     "Poison slash",
    #     "A slash of poisonous dust.",
    #     "poison_slash",
    #     40, 0, 0,
    #     0, 0, 15,
    #     "cut_hit",
    #     "rpg_battle_2/sounds/slash.ogg",
    #     )

init: # spells
    image ice_hit:
        Crop((240, 256, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((240, 224, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((240, 192, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((240, 224, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        Crop((240, 256, 32, 32), "rpg_battle_2/sprites.png")
        pause .1
        ease .2 alpha 0
    image hail_packt:
        Crop((240, 64, 32, 32), "rpg_battle_2/sprites.png")
    default hail_packt = spell(
        "Hail pact",
        "A normal-sized hail with unusually high speed.",
        "hail_packt",
        40, 0, 0,
        0, 30, 0,
        "ice_hit",
        "rpg_battle_2/sounds/ice.ogg",
        )
    image ice_shards:
        Crop((240, 96, 32, 32), "rpg_battle_2/sprites.png")
    default ice_shards = spell(
        "Ice shards",
        "Water that freezes after throwing.",
        "ice_shards",
        30, 0, 0,
        0, 15, 0,
        "ice_hit",
        "rpg_battle_2/sounds/ice.ogg",
        )
    image frost_creep:
        Crop((240, 128, 32, 32), "rpg_battle_2/sprites.png")
    default frost_creep = spell(
        "Poison slash",
        "Frost that creeps up from beneath you.",
        "frost_creep",
        15, 0, 0,
        0, 5, 0,
        "ice_hit",
        "rpg_battle_2/sounds/ice.ogg",
        )

init: # fighters
    image Koume:
        Crop((0, 0, 48, 64), "rpg_battle_2/sprites.png")
    image Chiyako:
        Crop((48, 0, 48, 64), "rpg_battle_2/sprites.png")
    image Seiko:
        Crop((96, 0, 48, 64), "rpg_battle_2/sprites.png")
    image Nomi:
        Crop((144, 0, 48, 64), "rpg_battle_2/sprites.png")
    image Aira:
        Crop((192, 0, 48, 64), "rpg_battle_2/sprites.png")
    image Michi:
        Crop((240, 0, 48, 64), "rpg_battle_2/sprites.png")

    image lab_bg = "rpg_battle_2/bg.png"

    image battle_caster_mark:
        Crop((480, 0, 16, 32), "rpg_battle_2/sprites.png")
    image battle_target_mark:
        Crop((496, 0, 16, 32), "rpg_battle_2/sprites.png")
    image fight_spell_frame:
        Crop((480, 32, 32, 32), "rpg_battle_2/sprites.png")

    default Koume = fighter(
        "Koume",
        "N/A",
        "Koume",
        225,40,40,
        [force_pinch, force_impact, force_gravity],
        )
    default Chiyako = fighter(
        "Chiyako",
        "N/A",
        "Chiyako",
        150,40,40,
        [poison_scratch, poison_swirl, poison_slash],
        )
    default Seiko = fighter(
        "Seiko",
        "N/A",
        "Seiko",
        100,40,40,
        [inner_fire, fire_ball],
        )
    default Nomi = fighter(
        "Nomi",
        "N/A",
        "Nomi",
        200,40,40,
        [iron_punch],
        )
    default Aira = fighter(
        "Aira",
        "N/A",
        "Aira",
        300,40,40,
        [golden_cut],
        )
    default Michi = fighter(
        "Michi",
        "N/A",
        "Michi",
        175,40,40,
        [hail_packt, ice_shards, frost_creep],
        )

label battle_example:
    call screen battle_screen

